abuild.in 33.7 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24
apk_opt_wait="--wait 30"
25

Natanael Copa's avatar
Natanael Copa committed
26
# read config
Natanael Copa's avatar
Natanael Copa committed
27
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
28 29
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

30
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
31 32 33 34 35 36
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
37 38 39 40 41 42 43 44 45 46 47 48 49 50
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
75 76

	
Linux User's avatar
Linux User committed
77
set_xterm_title() {
78
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
79
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
80 81 82 83 84
	fi
} 

cleanup() {
	set_xterm_title ""
85
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
86 87
		msg "Uninstalling dependencies..."
		$SUDO $APK del --quiet $apk_opt_wait $uninstall_after
88
	fi
Linux User's avatar
Linux User committed
89 90
}

Natanael Copa's avatar
Natanael Copa committed
91
die() {
Linux User's avatar
Linux User committed
92
	error "$@"
Linux User's avatar
Linux User committed
93
	cleanup
Natanael Copa's avatar
Natanael Copa committed
94 95 96
	exit 1
}

97 98
# check if apkbuild is basicly sane
sanitycheck() {
99
	local i= j= suggestion=
100
	msg "Checking sanity of $APKBUILD..."
101 102 103
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
104
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
105
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
106 107
			die "$pkgver is not a valid version"
	fi
108
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
109 110 111 112
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

113 114 115 116 117 118 119 120 121 122
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
123
	for i in $install; do
124 125 126 127 128 129 130 131 132
		local n=${i%.*}
		local suff=${i#*.}
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
			die "$i: install script does not match pkgname or any subpackages"
		fi
Natanael Copa's avatar
Natanael Copa committed
133 134 135 136 137 138
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

139 140
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
141 142 143 144
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
145
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
146 147 148
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
149 150
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
151

152 153
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
154
			source_has $i || die "$i exists in md5sums but is missing in source"
155 156
		done
	fi
157

158 159 160
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
161 162

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
163 164

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
165 166 167 168
	return 0
}

md5check() {
169
	local dummy f endreturnval originalparams origin file
170 171 172
	if [ -z "$source" ]; then
		return 0
	fi
173
	if [ -z "$md5sums" ]; then
174
		die "Use 'abuild checksum' to generate/update the checksum(s)"
175
	fi
176 177 178
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
179
	fetch || return 1
180
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
181
	cd "$srcdir" || return 1
182 183 184 185 186 187 188 189
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
190
			endreturnval=1
191 192 193 194 195 196 197 198 199 200 201
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
202 203
}

Natanael Copa's avatar
Natanael Copa committed
204 205
# verify upstream sources
sourcecheck() {
206 207 208 209 210 211 212 213 214 215
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
216
	done
217
	return 0
Natanael Copa's avatar
Natanael Copa committed
218
}
219

Natanael Copa's avatar
Natanael Copa committed
220 221
uri_fetch() {
	local uri="$1"
222
	local d="${uri##*/}"	# $(basename $uri)
223 224 225 226
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

227 228 229 230 231
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
232
	esac
233 234 235 236 237

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
Natanael Copa's avatar
Natanael Copa committed
238
	
Natanael Copa's avatar
Natanael Copa committed
239
	mkdir -p "$SRCDEST"
240 241 242
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
243
	fi
Linux User's avatar
Linux User committed
244
	msg "Fetching $uri"
245 246
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
247 248
}

249 250
is_remote() {
	case "$1" in
251
		http://*|ftp://*|https://*|saveas-*://*)
252 253 254 255 256
			return 0;;
	esac
	return 1
}

257 258 259 260 261
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
262 263 264 265 266
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
267 268 269 270
	fi
	uri_fetch "$uri"
}

271
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
272 273
	local s
	mkdir -p "$srcdir"
274 275
	for s in $source; do
		if is_remote "$s"; then
276
			uri_fetch_mirror "$s" || return 1
277 278 279 280
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
281 282 283
	done
}

284 285 286 287
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
288 289 290 291 292 293 294 295 296 297 298 299 300 301 302
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
303
# unpack the sources
304
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
305
	local u
306 307
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
308
		initdcheck || return 1
309
	fi
Natanael Copa's avatar
Natanael Copa committed
310 311 312 313
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
314
			*.tar.gz|*.tgz)
315
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
316 317
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
318
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
319
				tar -C "$srcdir" -jxf "$s" || return 1;;
320 321 322 323
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
324 325 326
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
327 328 329
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
330 331 332 333
		esac
	done
}

334 335 336 337
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
338 339
# cleanup source and package dir
clean() {
340
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
341
	rm -rf "$srcdir"
342
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
343 344 345 346 347 348
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
349 350 351 352
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
353 354 355
	done
}

356 357 358 359 360 361 362 363 364 365
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
366 367
cleanpkg() {
	local i
368
	getpkgver || return 1
369
	msg "Cleaning built packages..."
370
	for i in $(listpkgnames); do
371 372
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
373
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
374
	done
375
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
376 377
}

378 379 380
# clean all packages except current
cleanoldpkg() {
	local i j
381
	getpkgver || return 1
382
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
383
	for i in $(listpkgnames); do
384 385 386 387 388
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
389 390 391 392
		done
	done
	return 0
}
393 394 395 396 397

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
398
			local gopt=
399
			msg "Creating user $i"
400 401 402 403
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
			$SUDO adduser -D -H $gopt $i || return 1
404 405 406 407 408 409 410 411 412 413 414
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
415 416
runpart() {
	local part=$1
417
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
418 419 420 421
	$part || die "$part failed"
}

# override those in your build script
422 423 424 425 426 427 428 429
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
430 431 432 433
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
434
build() {
435
	:
Natanael Copa's avatar
Natanael Copa committed
436 437
}

438 439 440
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
441
	mkdir -p "$PKGDEST"
442 443 444
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
445 446 447 448 449 450 451 452 453
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

454
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
455 456
	local i
	cd "$startdir"
457
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
458 459
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
460
		msg "Running split function $func..."
461
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
462
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
463 464 465
	done
}

466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487
lang_subpkg() {
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
	mkdir -p "$subpkgdir"/usr/share/locale
	mv "$pkgdir"/usr/share/locale/$lang* \
		"$subpkgdir"/usr/share/locale/ \
		|| return 1
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

488 489 490 491 492 493 494 495 496 497 498 499
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

500 501 502 503 504 505
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

506
prepare_metafiles() {
507
	getpkgver || return 1
508 509
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
510
	local dir=${subpkgdir:-$pkgdir}
511
	local pkg="$name-$pkgver-r$pkgrel.apk"
512
	local pkginfo="$controldir"/.PKGINFO
513
	local sub
Natanael Copa's avatar
Natanael Copa committed
514 515 516
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
517
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
518 519
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
520
	local parch="$CARCH"
521 522 523 524 525

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
526

527
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
528
	if [ -n "$FAKEROOTKEY" ]; then
529
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
530
	fi
531 532
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
533
pkgname = $name
534
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
535 536 537 538 539
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
540
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
541
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
542
EOF
543 544
	local i deps
	deps="$depends"
545
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
546 547
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
548 549 550 551 552
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
553 554
	fi
	
555 556 557 558 559 560 561 562 563 564
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
565
	for i in $license; do
566
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
567 568
	done
	for i in $replaces; do
569
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
570
	done
571
	for i in $deps; do
572
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
573 574
	done
	for i in $conflicts; do
575
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
576 577
	done
	for i in $provides; do
578
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
579
	done
Natanael Copa's avatar
Natanael Copa committed
580 581 582
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
583 584 585
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
586 587

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
588
	for i in $install ${triggers%%:*}; do
589 590 591 592
		local n=${i%.*}
		if [ "$n" != "$pkgname" ]; then
			continue
		fi
593
		script=${i#$name}
594
		msg "Adding $script"
Natanael Copa's avatar
Natanael Copa committed
595
		cp "$startdir/$i" "$controldir/$script" || return 1
596
		chmod +x "$controldir/$script"
597 598
		metafiles="$metafiles $script"
	done
599
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
600
}
601

602 603
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
604
	[ "$arch" = "noarch" ] && return 0
605
	options_has "!tracedeps" && return 0
606
	# lets tell all the .so files this package provides in .provides-so
607 608
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
609 610 611 612 613
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
614
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
615 616 617
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
618 619
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
620
	done
Natanael Copa's avatar
Natanael Copa committed
621 622
}

623 624 625 626 627 628 629 630 631 632 633 634
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

635 636 637 638 639
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

640 641 642 643 644 645 646
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
647 648 649
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
650 651 652 653
	fi
	return 0
}

654
prepare_package() {
655
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
656
	stripbin
657 658
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
659 660 661 662 663 664 665 666
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

690 691 692
trace_apk_deps() {
	local name="$1"
	local dir="$2"
Natanael Copa's avatar
Natanael Copa committed
693
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
694
	msg "Tracing dependencies for $name..."
695 696 697
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
698
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
699 700 701 702
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
703
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
704 705
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
706
		msg "  added libgcc (due to libpthread)"
707
	fi
708
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
709
		found=
710
		# first check if its provide by same apkbuild
711
		for j in "$dir"/../.control.*/.provides-so; do
712
			grep -w "$i" "$j" >/dev/null || continue
713
			found=${j%/.provides-so}
714
			found=${found##*/.control.}
715
			break
716
		done
717 718 719 720 721 722
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
723
		fi
724 725 726
	done

	# find all packages that holds the so files
727 728 729 730 731
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

732
	for found in $self_provided $deppkgs; do
733
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
734 735 736
			warning "You can remove '$found' from depends"
			continue
		fi
737 738
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
739
			msg "  added $found"
740
		fi
741
	done
742

743 744 745 746 747 748 749
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

750 751
create_apks() {
	local file
752
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
753
	mkdir -p "$PKGDEST"
754
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
755 756 757
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
758
		local apk=$name-$ver.apk
759
		local datadir="$pkgbasedir"/$name
760 761

		trace_apk_deps "$name" "$dir" || return 1
762
		msg "Creating $apk..."
763
		(
764 765
		cd "$datadir"
		# data.tar.gz
766 767 768 769 770 771
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
772 773 774 775 776 777

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
778
		cd "$dir"
779 780
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
781
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
782

783 784 785
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
786 787 788
	done
}

789
clean_abuildrepo() {
790
	local apk
791 792 793
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
794
	for d in "$abuildrepo/$CARCH"; do
795 796
		[ -L "$d" ] && rm "$d"
	done
797

798 799
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
800 801 802 803
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
804
}
805

806
mklinks_abuildrepo() {
807 808
	local apk
	mkdir -p "$abuildrepo"/$CARCH
809
	cd "$abuildrepo" || return 1
810
	# create links for this package
811
	for apk in $(listpkg); do
812
		[ -f "$PKGDEST"/$apk ] || continue
813
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
814
	done
815 816 817 818 819 820 821 822 823 824 825 826 827 828
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
829

830
	msg "Updating the cached abuild repository index..."
831 832
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
833 834
	if [ -f "$index" ]; then
		oldindex="--index $index"
835
	fi
836
	$APK index --quiet $oldindex --output "$index".unsigned \
837
		--description "$repo $(cd $startdir && git describe)" \
838 839
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
840
	msg "Signing the index..."
841 842 843
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
844 845
}

846
# predefined splitfunc doc
847
default_doc() {
848
	depends="$depends_doc"
Natanael Copa's avatar
Natanael Copa committed
849
	triggers="$triggers_doc"
850
	pkgdesc="$pkgdesc (documentation)"
851
	arch=${arch_doc:-"noarch"}
852

Natanael Copa's avatar
Natanael Copa committed
853
	local i
854
	for i in doc man info html sgml licenses gtk-doc; do
855 856 857
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
858 859
		fi
	done
860 861 862
	
	rm -f "$subpkgdir/usr/share/info/dir"

863 864 865
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
866 867 868 869

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
870
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
871 872 873
	return 0
}

874 875 876 877
doc() {
	default_doc
}

878
# predefined splitfunc mod
879
default_mod() {
880
	depends="$kernel $depends_mod"
Natanael Copa's avatar
Natanael Copa committed
881
	for i in firmware modules; do
882 883 884
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
885
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
886 887 888 889
		fi
	done
}

890 891 892 893
mod() {
	default_mod
}

894
# predefined splitfunc dev
895
default_dev() {
896
	local i= j=
897
	depends="$pkgname $depends_dev"
Natanael Copa's avatar
Natanael Copa committed
898
	triggers="$triggers_dev"
899 900
	pkgdesc="$pkgdesc (development files)"

901 902 903 904
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
905
	cd "$pkgdir" || return 0
906 907
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
908
			usr/share/vala/vapi usr/share/gir-[0-9]*\
909 910 911
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
912 913
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
914
			mkdir -p "$d"
915
			mv "$pkgdir/$i" "$d"
916
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
917 918
		fi
	done
919 920 921 922 923 924 925
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
926
	return 0
Natanael Copa's avatar
Natanael Copa committed
927 928
}

929 930 931 932
dev() {
	default_dev
}

933 934 935 936
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

937 938 939 940 941 942 943 944
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
945 946
# build and package in fakeroot
rootpkg() {
947 948 949 950
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
951
		do_build=package
952
	fi
Natanael Copa's avatar
Natanael Copa committed
953
	cd "$startdir"
954
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
955
	do_fakeroot "$abuild_path" $color_opt $do_build \
956
		prepare_subpackages \
957
		prepare_language_packs \
958
		prepare_package \
959
		create_apks
Natanael Copa's avatar
Natanael Copa committed
960 961 962
}

srcpkg() {
963
	getpkgver || return 1
964
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
965
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
966 967 968 969 970
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
971
	msg "Creating source package $p.src.tar.gz..."
972
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
973 974
}

Natanael Copa's avatar
Natanael Copa committed
975 976
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
977
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
978 979
}

980
# check if package is up to date
981
apk_up2date() {
982
	getpkgver || return 1
983
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
984
	local i s
Natanael Copa's avatar
Natanael Copa committed
985
	cd "$startdir"
986 987 988 989 990
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

991
	for i in $source APKBUILD; do
992 993 994 995 996 997
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
998 999 1000 1001 1002 1003 1004
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

1005
abuildindex_up2date() {
1006
	local i
1007
	getpkgver || return 1
1008 1009 1010 1011 1012 1013 1014
	local dir="$abuildrepo"/$CARCH
	local apk="${pkgname%:*}-$pkgver-r$pkgrel.apk"
	local idx="$dir"/APKINDEX.tar.gz
	local file="$dir"/$apk

	# check if index is missing
	[ -f "$idx" ] || return 1
1015
			
1016 1017 1018 1019 1020
	# if link or file is missing, then we need update abuildrepo index
	[ -f "$file" ] || return 1

	# if file exists and is newer than index, then we need update index
	[ "$file" -nt "$idx" ] && return 1
1021
		
1022 1023 1024 1025
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
1026
	check_arch || return 0
1027 1028 1029 1030 1031 1032 1033
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
1034 1035
}

1036 1037 1038 1039 1040 1041 1042
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
1043 1044
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
1045 1046 1047 1048
		pkgname=
		subpackages=
		depends=
		makedepends=
1049
		. $i
1050
		dir=${i%/APKBUILD}
1051
		deps=
1052
		# filter out conflicts from deps and version info
1053 1054 1055 1056
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
1057
			deps="$deps ${j%%[<>=]*}"
1058
		done
1059
		for j in $pkgname $subpackages; do
1060
			echo "o ${j%%:*} $dir"
1061
			set -- $deps
1062 1063 1064 1065 1066 1067 1068
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
1069 1070
		done
	done
1071
	)
1072 1073
}

1074
deptrace() {
1075 1076 1077
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
1078
		deps="$deps ${i%%[<>=]*}"
1079
	done
1080
	[ -z "$deps" ] && return 0
1081 1082 1083
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
1084
			$APK info -q | sort |  sed 's/^/i /'
1085
		fi
1086
	) | awk -v pkgs="$deps" '
1087 1088 1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100 1101 1102 1103 1104 1105 1106 1107 1108 1109 1110 1111

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
1112
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
1113
	local filtered_deps= conflicts=
1114
	[ -n "$nodeps" ] && return 0
1115
	msg "Analyzing dependencies..."
1116

1117 1118 1119
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
1120
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
1121 1122
	done

1123
	installed_deps=$($APK info -e $deps)
1124
	# find which deps are missing
1125
	for i in $deps; do
1126
		if [ "${i#\!}" != "$i" ]; then
1127
			$APK info -q -e "${i#\!}" \
1128
				&& conflicts="$conflicts ${i#\!}"
1129
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
1130 1131 1132
			missing="$missing $i"
		fi
	done
1133
	
1134
	if [ -n "$conflicts" ]; then
1135 1136
		error "Conflicting package(s) installed:$conflicts"
		return 1
1137 1138 1139 1140 1141 1142 1143 1144
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
1145